<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Tutorial: conceptUnitTest</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Tutorial: conceptUnitTest</h1>

    <section>

<header>
    

    <h2>conceptUnitTest</h2>
</header>

<article>
    <pre class="prettyprint source lang-javascript"><code>&quot;devDependencies&quot;: {
    &quot;chai&quot;: &quot;^4.3.4&quot;,
    &quot;chai-as-promised&quot;: &quot;^7.1.1&quot;,
    &quot;eslint&quot;: &quot;^7.30.0&quot;,
    &quot;eslint-config-airbnb-base&quot;: &quot;^14.2.1&quot;,
    &quot;eslint-plugin-import&quot;: &quot;^2.23.4&quot;,
    &quot;jsdoc&quot;: &quot;^3.6.7&quot;,
    &quot;mocha&quot;: &quot;^9.0.2&quot;,
    &quot;mocha-simple-html-reporter&quot;: &quot;^2.0.0&quot;,
    &quot;mochawesome&quot;: &quot;^6.2.2&quot;,
    &quot;mock-socket&quot;: &quot;^9.0.3&quot;,
    &quot;nodemon&quot;: &quot;^2.0.7&quot;,
    &quot;nyc&quot;: &quot;^15.1.0&quot;,
    &quot;socket.io-client&quot;: &quot;^4.1.3&quot;,
    &quot;socket.io-mock&quot;: &quot;^1.3.2&quot;,
    &quot;supertest&quot;: &quot;^6.1.3&quot;
  },
</code></pre>
<pre class="prettyprint source lang-javascript"><code>&quot;scripts&quot;: {
    &quot;start&quot;: &quot;node index&quot;,
    &quot;dev&quot;: &quot;nodemon index&quot;,
    &quot;test&quot;: &quot;mocha './test/**/*.spec.js' --watch&quot;,
    &quot;test:awesome&quot;: &quot;mocha --reporter mochawesome || true&quot;,
    &quot;test:report&quot;: &quot;mocha --reporter mocha-simple-html-reporter --reporter-options output=report.html&quot;,
    &quot;doc&quot;: &quot;jsdoc -c jsdoc.json --readme Readme.md&quot;,
    &quot;coverage&quot;: &quot;nyc --reporter=text npm run test&quot;
  },
</code></pre>
<pre class="prettyprint source lang-javascript"><code>{
    // Use IntelliSense to learn about possible attributes.
    // Hover to view descriptions of existing attributes.
    // For more information, visit: https://go.microsoft.com/fwlink/?linkid=830387
    &quot;version&quot;: &quot;0.2.0&quot;,
    &quot;configurations&quot;: [
        {                   
            &quot;name&quot;: &quot;Mocha Tests&quot;,
            &quot;program&quot;: &quot;${workspaceFolder}/node_modules/mocha/bin/_mocha&quot;,
            &quot;request&quot;: &quot;launch&quot;,
            &quot;skipFiles&quot;: [
                &quot;&lt;node_internals>/**&quot;
            ],
            &quot;type&quot;: &quot;pwa-node&quot;
        },
        
        {
            &quot;type&quot;: &quot;pwa-node&quot;,
            &quot;request&quot;: &quot;launch&quot;,
            &quot;name&quot;: &quot;Launch Program&quot;,
            &quot;skipFiles&quot;: [
                &quot;&lt;node_internals>/**&quot;
            ],
            &quot;program&quot;: &quot;${workspaceFolder}/index.js&quot;
        }
    ]
}
</code></pre>
<p>Currently used tests :</p>
<pre class="prettyprint source lang-javascript"><code>const request = require('supertest');
const app = require('../index.js');
const assert = require(&quot;chai&quot;).assert;

describe(&quot;Main route GET / - check if the HTML file for the Algebraic Engine Model is sent&quot;, function(){
    it(&quot;is 200&quot;, function(done){  
      request(app)
        .get(&quot;/&quot;)
        .expect(&quot;Content-type&quot;,/html/)
        .expect(200)
        .end(function(err, res){                      
          assert.include(res.text, &quot;&lt;title>Stationary / Algebraic Engine Model&lt;/title>&quot;)
          done();
        })
    })
  });
</code></pre>
<pre class="prettyprint source lang-javascript"><code>var io = require('socket.io-client');
require('../nodeScripts/socketCom.js');
const assert = require(&quot;chai&quot;).assert;

var socketURL = 'http://localhost:3000';

var options ={
  transports: ['websocket'],
  'force new connection': true
};
  
describe(&quot;Socket test&quot;,function(){

  /* Test 1 - A Single User */
  it('Connect socket server and check if the returned time stamp has the correct format',function(done){
    var client = io.connect(socketURL, options);

    client.on('connect',function(data){
      //client.emit('connection name',chatUser1);
      console.log('connected');
    });

    client.on('time',function(res){

      /* If this client doesn't disconnect it will interfere 
      with the next test */
      assert.include(res, &quot;GMT&quot;)
      client.disconnect();
      done(); 
    });
    //'thermdata'
  });
</code></pre>
<pre class="prettyprint source lang-javascript"><code>var io = require('socket.io-client');
require('../nodeScripts/socketCom.js');
const assert = require(&quot;chai&quot;).assert;

var socketURL = 'http://localhost:3000';

var options ={
  transports: ['websocket'],
  'force new connection': true
};

describe(&quot;Socket test&quot;,function(){

    /* Test 1 - A Single User */
    it('Connect socket server and check if the returned time stamp has the correct format',function(done){
      var client = io.connect(socketURL, options);
  
      client.on('connect',function(data){
        //client.emit('connection name',chatUser1);
        console.log('connected');
      });
  
      client.on('time',function(res){
  
        /* If this client doesn't disconnect it will interfere 
        with the next test */
        assert.include(res, &quot;GMT&quot;)
        client.disconnect();
        done(); 
      });
      //'thermdata'
    });
</code></pre>
<h3>Should</h3>
<pre class="prettyprint source lang-javascript"><code>chai.should();

foo.should.be.a('string');
foo.should.equal('bar');
foo.should.have.lengthOf(3);
tea.should.have.property('flavors')
  .with.lengthOf(3);
</code></pre>
<h3>Expect</h3>
<pre class="prettyprint source lang-javascript"><code>var expect = chai.expect;

expect(foo).to.be.a('string');
expect(foo).to.equal('bar');
expect(foo).to.have.lengthOf(3);
expect(tea).to.have.property('flavors')
  .with.lengthOf(3);
</code></pre>
<h3>Assert</h3>
<pre class="prettyprint source lang-javascript"><code>var assert = chai.assert;

assert.typeOf(foo, 'string');
assert.equal(foo, 'bar');
assert.lengthOf(foo, 3)
assert.property(tea, 'flavors');
assert.lengthOf(tea.flavors, 3);
</code></pre>
<pre class="prettyprint source lang-javascript"><code>var MyClass = require(&quot;../src/myclass.js&quot;);
var sinon = require(&quot;sinon&quot;);
var myObj = new MyClass();
var chai = require(&quot;chai&quot;);
var expect = chai.expect;
const chaiaspromise = require(&quot;chai-as-promised&quot;);
chai.use(chaiaspromise);
const nock = require(&quot;nock&quot;);
</code></pre>
<h3>Sinon Spy</h3>
<p>A test spy is a function that records arguments, return value, the value of this and exception thrown (if any) for all its calls.</p>
<h3>Sinon Fakes</h3>
<p>Unlike sinon.spy and sinon.stub methods, the sinon.fake API knows only how to create fakes, and doesn’t concern itself with plugging them into the system under test. To plug the fakes into the system under test, you can use the sinon.replace* methods.</p>
<pre class="prettyprint source lang-javascript"><code>require(&quot;@fatso83/mini-mocha&quot;).install();
const sinon = require(&quot;sinon&quot;);
const PubSub = require(&quot;pubsub-js&quot;);
const referee = require(&quot;@sinonjs/referee&quot;);
const assertTrue = referee.assert;

describe(&quot;PubSub&quot;, function () {
    it(&quot;should call subscribers on publish&quot;, function () {
        // Dummy callback function as an object
        const callback = sinon.spy();

        PubSub.subscribe(&quot;message&quot;, callback);
        PubSub.publishSync(&quot;message&quot;);

        assertTrue(callback.called);
    });
});
</code></pre>
<p>sinon.spy(object)</p>
<pre class="prettyprint source lang-javascript"><code>require(&quot;@fatso83/mini-mocha&quot;).install();
const sinon = require(&quot;sinon&quot;);
const PubSub = require(&quot;pubsub-js&quot;);
const referee = require(&quot;@sinonjs/referee&quot;);
const assertTrue = referee.assert;

describe(&quot;PubSub&quot;, function () {
    it(&quot;should call subscribers on publish&quot;, function () {
        // Dummy callback function as an object
        const callback = sinon.spy();

        PubSub.subscribe(&quot;message&quot;, callback);
        PubSub.publishSync(&quot;message&quot;);

        assertTrue(callback.called);
    });
});
</code></pre>
<p>Spies all the object’s methods.</p>
<p>In software architecture, publish–subscribe is a messaging pattern where senders of messages, called publishers, do not program the messages to be sent directly to specific receivers, called subscribers, but instead categorize published messages into classes without knowledge of which subscribers, if any, there may be. Similarly, subscribers express interest in one or more classes and only receive messages that are of interest, without knowledge of which publishers, if any, there are.</p>
<p>Creating spies: sinon.spy() Method Signatures
(Function/Method signature : name and the number of arguments)</p>
<h3>Anonymous function</h3>
<p>var spy = sinon.spy();
Creates an anonymous function that records arguments, this value, exceptions and return values for all calls.</p>
<h3>Wrap the function by a spy / spy may be called instead of the function</h3>
<p>var spy = sinon.spy(myFunc);
Wraps the function in a spy. You can pass this spy where the original function would otherwise be passed when you need to verify how the function is being used.</p>
<h3>Replace object method with the spy - if property is a function</h3>
<p>var spy = sinon.spy(object, &quot;method&quot;);
Creates a spy for object.method and replaces the original method with the spy. An exception is thrown if the property is not already a function. The spy acts exactly like the original method in all cases. The original method can be restored by calling object.method.restore(). The returned spy is the function object which replaced the original method. spy === object.method.</p>
<h3>Replace object property with the spy - the property can be restored</h3>
<p>var spy = sinon.spy(object, &quot;property&quot;, types);
Creates a spy for the property object.property which replaces the descriptor with an equivalent where each specified accessor (types parameter) has been wrapped as a spy. The returned object, unlike regular spies, is a property descriptor containing the wrapped accessors (spies). The original accessors can be restored by calling spy.get.restore() (where get is the accessor you wish to restore).</p>
<h3>Stubs</h3>
<p>Test stubs are functions (spies) with pre-programmed behavior.</p>
<p>They support the full test spy API in addition to methods which can be used to alter the stub’s behavior.</p>
<p>As spies, stubs can be either anonymous, or wrap existing functions. When wrapping an existing function with a stub, the original function is not called.</p>
<h3>When to use stubs</h3>
<p>Use a stub when you want to:</p>
<pre><code>Control a method’s behavior from a test to force the code down a specific path. Examples include forcing a method to throw an error in order to test error handling.

When you want to prevent a specific method from being called directly (possibly because it triggers undesired behavior, such as a XMLHttpRequest or similar).
</code></pre>
<p>The following example is yet another test from PubSubJS which shows how to create an anonymous stub that throws an exception when called.</p>
<pre class="prettyprint source lang-javascript"><code>require(&quot;@fatso83/mini-mocha&quot;).install();

const sinon = require(&quot;sinon&quot;);
const PubSub = require(&quot;pubsub-js&quot;);
const referee = require(&quot;@sinonjs/referee&quot;);
const assert = referee.assert;

describe(&quot;PubSub&quot;, function () {
    it(&quot;should call all subscribers, even if there are exceptions&quot;, function () {
        const message = &quot;an example message&quot;;
        // Throw exception as a default behaviour
        const stub = sinon.stub().throws();
        const spy1 = sinon.spy();
        const spy2 = sinon.spy();
        const clock = sinon.useFakeTimers();

        PubSub.subscribe(message, stub);
        PubSub.subscribe(message, spy1);
        PubSub.subscribe(message, spy2);

        assert.exception(() => {
            PubSub.publishSync(message, &quot;some data&quot;);

            // PubSubJS reschedules exceptions using setTimeout(fn,0)
            // We have faked the clock, so just tick the clock to throw!
            clock.tick(1);
        });

        assert.exception(stub);
        assert(spy1.called);
        assert(spy2.called);
        assert(stub.calledBefore(spy1));

        clock.restore();
    });
});
</code></pre>
<pre class="prettyprint source lang-javascript"><code>describe(&quot;Test suit for stub&quot;, function() {
  it(&quot;Stub the add method&quot;, function() {
    var stub = sinon.stub(myObj, &quot;add&quot;);
    stub
      .withArgs(10, 20)
      .onFirstCall()
      .returns(100)
      .onSecondCall()
      .returns(200);
    expect(myObj.callAnotherFn(10, 20)).to.be.equal(100);
    expect(myObj.callAnotherFn(10, 20)).to.be.equal(200);
  });
});
</code></pre>
<p>Note how the stub also implements the spy interface. The test verifies that all callbacks were called, and also that the exception throwing stub was called before one of the other callbacks.</p>
<pre class="prettyprint source lang-javascript"><code>require(&quot;@fatso83/mini-mocha&quot;).install();

const sinon = require(&quot;sinon&quot;);
const referee = require(&quot;@sinonjs/referee&quot;);
const assert = referee.assert;

const myObj = {};
myObj.prop = function propFn() {
    return &quot;foo&quot;;
};

describe(&quot;stub&quot;, function () {
    it(&quot;should call fake&quot;, function () {
        sinon.stub(myObj, &quot;prop&quot;).callsFake(function fakeFn() {
            return &quot;bar&quot;;
        });

        assert.equals(myObj.prop(), &quot;bar&quot;);
    });
});
</code></pre>
<h4>Using mocks</h4>
<pre class="prettyprint source lang-javascript"><code> it(&quot;mock the sayHello method&quot;, function() {
    // Create a wrapper around the object
    var mock = sinon.mock(myObj);
    // The sayHello function is to be mocked
    var expectation = mock.expects(&quot;sayHello&quot;);
    // mock it only one time
    expectation.exactly(1);
    // 
    expectation.withArgs(&quot;hello world&quot;);
    myObj.callAnotherFn(10, 20);
    mock.verify();
  });
</code></pre>
<h4>Using fakes instead of spies</h4>
<pre class="prettyprint source lang-javascript"><code>require(&quot;@fatso83/mini-mocha&quot;).install();
const sinon = require(&quot;sinon&quot;);
const referee = require(&quot;@sinonjs/referee&quot;);
const assert = referee.assert;

describe(&quot;FakeTest&quot;, function () {
    it(&quot;should be able to be used instead of spies&quot;, function () {
        const foo = {
            bar: () => &quot;baz&quot;,
        };
        // wrap existing method without changing its behaviour
        const fake = sinon.replace(foo, &quot;bar&quot;, sinon.fake(foo.bar));

        assert.equals(fake(), &quot;baz&quot;); // behaviour is the same
        assert.equals(fake.callCount, 1); // calling information is saved
    });
});
</code></pre>
<h3>Testing promises</h3>
<p>Option 1 :</p>
<pre class="prettyprint source lang-javascript"><code>
// After chai.use the assertion lib chai will 
// offer special functions to handle promises
// see to.eventually.equal(6) in the code below
const chaiaspromise = require(&quot;chai-as-promised&quot;);
chai.use(chaiaspromise);

describe(&quot;Test the promise&quot;, function() {
  it(&quot;Promise test case&quot;, function(done) {
    this.timeout(4000);
    myObj.testPromise().then(function(result) {
      expect(result).to.be.equal(6);
      done();
    });
  });
});

describe(&quot;Test the promise&quot;, function() {
  it(&quot;Promise test case with chai-as-promised&quot;, function() {
    this.timeout(0);
    return expect(myObj.testPromise()).to.eventually.equal(6);
  });
});
</code></pre>
<p>The testing method 'it' offers a 'done' method which has to be called to declare a test as completed. In case3 of a promise
the 'done' method has to be called at the end of the 'then' part of the promise to indicate that a promise is completely processed.
The 'it' object  further offers a timeout method. By setting the timeout to 4000 a time window of 4 seconds is opened. The test finishes in these 4 seconds which means that in the given example the promise has to be resolved in 4 seconds.</p>
<p>By using the 'chai-as-promised' handlers of chai the 'done' method may be replaced by the to.eventually method which waits till the promise gets resolved.</p>
<h3>Mocking XHR calls (e.g. posts)</h3>
<pre class="prettyprint source lang-javascript"><code>  xhrFn() {
    return new Promise((resolve, reject) => {
      var xhr = new XMLHttpRequest();
      xhr.open(&quot;post&quot;, &quot;https://echo-service-new.herokuapp.com/echo&quot;, true);

      xhr.onreadystatechange = function() {
        if (xhr.readyState == 4) {
          if (xhr.status == 200) {
            resolve(JSON.parse(xhr.responseText));
          } else {
            reject(xhr.status);
          }
        }
      };
      xhr.send();
    })
      .then(function(result) {
        return result;
      })
      .catch(error => {
        return error;
      });
  }
}
</code></pre>
<p>The code snippet below shows a XMLHTTPRequest which is configured as a HTTP post request on a Web url. The post is sent to the web url by calling xhr.send method. The server responds by sending back a HTML body in a JSON format. If the xhr status is equal to 200 the reponse is positive and the reolve methode returns the JSON information as a Javascript object (JSON.parse). In case of an error the reject method returns the error code.</p>
<p>It takes seconds to get the reponse from the server. Should the reponse be obvious an not important for the test, one can alternatively mock the post request by using the nock object.</p>
<pre class="prettyprint source lang-javascript"><code>describe(&quot;XHR test suit&quot;, function() {
  it(&quot;Mock and stub xhr call&quot;, function(done) {
    var obj = { id: 123 };
    const scope = nock(&quot;https://echo-service-new.herokuapp.com&quot;)
      .post(&quot;/echo&quot;)
      .reply(200, obj);
    myObj
      .xhrFn()
      .then(function(result) {
        expect(result).to.be.eql(obj);
        done();
      })
      .catch(error => {
        done(new Error(&quot;test case failed: &quot; + error));
      });
  });
</code></pre>
<p>The 'nock' object creates a capsulse around the XMLHTTPRequest. The wrapper treats a failed test as a rejected promise. The catch statement gets triggered by the the test, such that a specific error reaction my be implemented in addition to the default test response
according to the 'expect' interface of chai.</p>
<h4>Moca Hooks</h4>
<ul>
<li>before : before the 'it' function</li>
<li>after : after the 'it' function</li>
<li>beforeEach: before each 'it' function in a test suite</li>
<li>afterEach: after each 'it' function in a test suite</li>
</ul>
<p>Example : if one tries to wrap a method x of an object with a spy, sinon will reply with the type error &quot;Attempted to wrap x which is already wrapped&quot;. The solution is to call sinon.restore().</p>
<h3>Spy in unit testing</h3>
<p>npm install --save-dev sinon</p>
<p>see https://sinonjs.org/releases/latest/</p>
<ul>
<li>
<p>Fakes</p>
</li>
<li>
<p>Spies</p>
</li>
<li>
<p>Stubs</p>
</li>
<li>
<p>Mocks</p>
</li>
<li>
<p>Spy Calls</p>
</li>
<li>
<p>Promises</p>
</li>
<li>
<p>Fake Timers</p>
</li>
<li>
<p>Fake XHR and server</p>
</li>
<li>
<p>JSON-P</p>
</li>
<li>
<p>Assertion</p>
</li>
<li>
<p>Matchers</p>
</li>
<li>
<p>Sandboxes</p>
</li>
<li>
<p>Utils</p>
</li>
<li>
<p>has function be called ?</p>
</li>
<li>
<p>if yes, how many times ?</p>
</li>
<li>
<p>what arguments ?</p>
</li>
<li>
<p>did it return something ?</p>
</li>
<li>
<p>what was returned ?</p>
</li>
</ul>
<pre class="prettyprint source lang-javascript"><code> after(function() {
    console.log(&quot;===================== After the test suit&quot;);
  });
  before(function() {
    console.log(&quot;===================== Before the test suit&quot;);
  });
  afterEach(function() {
    console.log(&quot;======= After every test case inside this test suit&quot;);
  });
  beforeEach(function() {
    // Sinon wrappers must be restored before or after a test case.
    // Hooks makes it easier implement
    sinon.restore();
    console.log(&quot;======= Before every test case inside this test suit&quot;);
  });
</code></pre>
<pre class="prettyprint source lang-javascript"><code>it(&quot;spy the add method&quot;, function() {
    var spy = sinon.spy(myObj, &quot;add&quot;);
    var arg1 = 10,
      arg2 = 20;
    myObj.callAnotherFn(arg1, arg2);
    //sinon.assert.calledTwice(spy);
    expect(spy.calledOnce).to.be.true;
    expect(spy.calledWith(10, 20)).to.be.true;
  });

  it(&quot;copy of spy the add method&quot;, function() {
    // This test will fail in case sinon.restore() is not called
    var spy = sinon.spy(myObj, &quot;add&quot;);
    var arg1 = 10,
      arg2 = 20;
    myObj.callAnotherFn(arg1, arg2);
    //sinon.assert.calledTwice(spy);
    expect(spy.calledOnce).to.be.true;
    expect(spy.calledWith(10, 20)).to.be.true;
  });

  it(&quot;spy the callabck method&quot;, function() {
    var callback = sinon.spy();
    myObj.callTheCallback(callback);
    expect(callback.calledOnce).to.be.true;
  });  
</code></pre>
<h3>Testing vanilla javascript modules by emulating the web browser</h3>
<p>see 'https://www.npmjs.com/package/jsdom'
'https://blog.logrocket.com/how-to-use-ecmascript-modules-with-node-js/'</p>
<p>CalledWith : check certain values of the call arguments</p>
</article>

</section>

</div>

<nav>
    <h2><a href="index.html">Connected Controls Web App Docu</a></h2><h3>Modules</h3><ul><li><a href="module-a_index_server.html">a_index_server</a></li><li><a href="module-b_create_caldata_buttons_client.html">b_create_caldata_buttons_client</a></li><li><a href="module-c_socketCom_server.html">c_socketCom_server</a></li><li><a href="module-d_handleModelData_client.html">d_handleModelData_client</a></li><li><a href="module-e_getModelStimulationData_server.html">e_getModelStimulationData_server</a></li><li><a href="module-f_getPostgresData_server.html">f_getPostgresData_server</a></li><li><a href="module-g_setPostgresData_server.html">g_setPostgresData_server</a></li><li><a href="module-h_deletePostgresData_server.html">h_deletePostgresData_server</a></li><li><a href="module-i_getPostgresWOsocket_server.html">i_getPostgresWOsocket_server</a></li><li><a href="module-j_updatePostgresData_server.html">j_updatePostgresData_server</a></li><li><a href="module-k_select-stimulation_client.html">k_select-stimulation_client</a></li><li><a href="module-l_3d_map_visualization_client.html">l_3d_map_visualization_client</a></li><li><a href="module-m_curveGraphGenerator_client.html">m_curveGraphGenerator_client</a></li><li><a href="module-n_create_simulation_view_client.html">n_create_simulation_view_client</a></li><li><a href="module-o_3d_map_visualization_initialization_client.html">o_3d_map_visualization_initialization_client</a></li><li><a href="module-p_3d_map_table_generator.html">p_3d_map_table_generator</a></li></ul><h3>Namespaces</h3><ul><li><a href="audio.k_1_startStimulation.html">k_1_startStimulation</a></li><li><a href="b_create_caldata_buttons_client.b_1_dataviz.html">b_1_dataviz</a></li><li><a href="b_create_caldata_buttons_client.b_1_dataviz.b_1_1_getClassNames.html">b_1_1_getClassNames</a></li><li><a href="b_create_caldata_buttons_client.b_1_dataviz.b_1_3_getAllButtonNames.html">b_1_3_getAllButtonNames</a></li><li><a href="b_create_caldata_buttons_client.b_1_dataviz.b_1_4_thermdata_client.html">b_1_4_thermdata_client</a></li><li><a href="c_socketCom_server.c_1_socketfunction.html">c_1_socketfunction</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html">c_1_1_socketConnected</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_1_initNewData.html">c_1_1_1_initNewData</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_2_tabledata.html">c_1_1_2_tabledata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_3_curvedata.html">c_1_1_3_curvedata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_4_getTable.html">c_1_1_4_getTable</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_5_getCurve.html">c_1_1_5_getCurve</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_6_getStimData.html">c_1_1_6_getStimData</a></li><li><a href="data.d_1_handler.html">d_1_handler</a></li><li><a href="m_curveGraphGenerator_client.m_1_curveGraphGenerator.html">m_1_curveGraphGenerator</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.html">n_1_create_simulation_view</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.n_1_1_rcvAudioFilePaths.html">n_1_1_rcvAudioFilePaths</a></li></ul><h3>Classes</h3><ul><li><a href="d3.html">d3</a></li><li><a href="express.html">express</a></li><li><a href="pool.html">pool</a></li><li><a href="response.html">response</a></li><li><a href="router.html">router</a></li><li><a href="selection.html">selection</a></li><li><a href="server.html">server</a></li><li><a href="socket.html">socket</a></li></ul><h3>Events</h3><ul><li><a href="b_create_caldata_buttons_client.b_1_dataviz.html#.event:thermdata">thermdata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:curvedata">curvedata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:disconnect">disconnect</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:getAudioFlPths">getAudioFlPths</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:getCurve">getCurve</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:getTable">getTable</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:initNewData">initNewData</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:tabledata">tabledata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:time">time</a></li><li><a href="c_socketCom_server.c_1_socketfunction.html#.event:connection">connection</a></li><li><a href="data.d_1_handler.html#.event:curvedata">curvedata</a></li><li><a href="data.d_1_handler.html#.event:initNewData">initNewData</a></li><li><a href="data.d_1_handler.html#.event:tabledata">tabledata</a></li><li><a href="module-e_getModelStimulationData_server.html#~event:sendAudioFlPths">sendAudioFlPths</a></li><li><a href="m_curveGraphGenerator_client.m_1_curveGraphGenerator.html#.event:getCurve">getCurve</a></li><li><a href="m_curveGraphGenerator_client.m_1_curveGraphGenerator.html#.event:sendCurve">sendCurve</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.html#.event:getAudioFlPths">getAudioFlPths</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.html#.event:periodic_time">periodic_time</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.html#.event:sendAudioFlPths">sendAudioFlPths</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.n_1_1_rcvAudioFilePaths.html#.event:click_stimFileSelector">click_stimFileSelector</a></li></ul><h3>Tutorials</h3><ul><li><a href="tutorial-codeAnalysisAndRefactoring.html">Static source code analysis and refactoring interface</a></li><li><a href="tutorial-conceptUnitTest.html">conceptUnitTest</a></li><li><a href="tutorial-graphicalEditor.html">Graphical editor for maps and curves</a></li><li><a href="tutorial-modelStimulation.html">Stimulation of physical and engine control models</a></li><li><a href="tutorial-staticEngineModel.html">Static combustion engine model</a></li><li><a href="tutorial-webclients.html">webclients</a></li></ul><h3>Global</h3><ul><li><a href="global.html#buildNav">buildNav</a></li><li><a href="global.html#publish">publish</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc/jsdoc">JSDoc 3.6.7</a> on Fri Sep 17 2021 09:09:23 GMT+0200 (Mitteleuropäische Sommerzeit)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>